/*
 * Copyright (C) 2019  Max Regan
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#pragma once

#include <array>

#include "Bsp/Drivers/DisplayDriver.h"
#include "Bsp/ReturnCode.h"
#include "Bsp/Task.h"
#include "Bsp/macros.h"

#include "Application/ButtonManager.h"
#include "Application/Screens/Screen.h"

class ScreenManager : public BSP::Schedule::Task {
public:

    ScreenManager(BSP::Schedule::TaskScheduler &scheduler,
                  BSP::DisplayDriver &display,
                  BSP::ButtonManager &buttons);

    BSP::ReturnCode init();
    BSP::ReturnCode set_root_screen(Screen &screen);

    BSP::Schedule::NextTime execute() override;

    BSP::ReturnCode pop_screen();
    BSP::ReturnCode push_screen(Screen &screen);
    BSP::ReturnCode set_screen(Screen &screen);

private:

    inline Screen *current_screen() {
        return m_screen_stack[m_screen_stack_depth - 1];
    }
    void notify_up_screen();
    void notify_middle_screen();
    void notify_down_screen();

    static constexpr std::size_t MAX_SCREEN_STACK = 5;

    BSP::Schedule::TaskScheduler &m_scheduler;

    std::array<Screen *, MAX_SCREEN_STACK> m_screen_stack;
    std::size_t m_screen_stack_depth;

    BSP::DisplayDriver &m_display;
    BSP::ButtonManager &m_buttons;
};
